import { GridApiCommon, GridColumnReorderApi, GridRowMultiSelectionApi, GridRowProApi } from '@mui/x-data-grid';
import { GridPrivateOnlyApiCommon, GridInfiniteLoaderPrivateApi } from '@mui/x-data-grid/internals';
import { GridInitialStatePro, GridStatePro } from "./gridStatePro.js";
import type { GridColumnPinningApi, GridDetailPanelApi, GridRowPinningApi, GridDetailPanelPrivateApi } from "../hooks/index.js";
import type { GridDataSourceApiPro, GridDataSourcePrivateApiPro } from "../hooks/features/dataSource/models.js";
import type { DataGridProProcessedProps } from "./dataGridProProps.js";
/**
 * The api of Data Grid Pro.
 */
export interface GridApiPro extends GridApiCommon<GridStatePro, GridInitialStatePro>, GridRowProApi, GridColumnPinningApi, GridDetailPanelApi, GridRowPinningApi, GridDataSourceApiPro, GridRowMultiSelectionApi, GridColumnReorderApi {}
export interface GridPrivateApiPro extends GridApiPro, GridPrivateOnlyApiCommon<GridApiPro, GridPrivateApiPro, DataGridProProcessedProps>, GridDetailPanelPrivateApi, GridInfiniteLoaderPrivateApi, GridDataSourcePrivateApiPro {}