"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.skipFiltering = skipFiltering;
exports.skipSorting = skipSorting;
var _xDataGrid = require("@mui/x-data-grid");
var _internals = require("@mui/x-data-grid/internals");
function skipFiltering(rowTree) {
  const filteredChildrenCountLookup = {};
  const nodes = Object.values(rowTree);
  for (let i = 0; i < nodes.length; i += 1) {
    const node = nodes[i];
    filteredChildrenCountLookup[node.id] = node.serverChildrenCount ?? 0;
  }
  return {
    filteredRowsLookup: _internals.defaultGridFilterLookup.filteredRowsLookup,
    filteredChildrenCountLookup,
    filteredDescendantCountLookup: _internals.defaultGridFilterLookup.filteredDescendantCountLookup
  };
}
function skipSorting(rowTree) {
  return (0, _internals.getTreeNodeDescendants)(rowTree, _xDataGrid.GRID_ROOT_GROUP_ID, false);
}